diff -ruN tarsnap-autoconf-1.0.33/lib/network/tsnetwork_register.c tarsnap-autoconf-1.0.34/lib/network/tsnetwork_register.c
--- tarsnap-autoconf-1.0.33/lib/network/tsnetwork_register.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/lib/network/tsnetwork_register.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,371 @@
+#include <sys/select.h>
+
+#include <assert.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include "elasticarray.h"
+#include "events.h"
+#include "warnp.h"
+
+#include "tsnetwork.h"
+#include "tsnetwork_internal.h"
+
+/* Callbacks. */
+struct callback {
+	network_callback * callback;
+	void * cookie;
+	int s;
+	int eop;
+	int event_network_pending;
+	void * event_timer;
+};
+ELASTICARRAY_DECL(CALLBACKS, callbacks, struct callback *);
+static CALLBACKS callbacks[2] = {NULL, NULL};
+static int suspended[2] = {0, 0};
+static int eops[2] = {EVENTS_NETWORK_OP_READ, EVENTS_NETWORK_OP_WRITE};
+
+/* Translate an "op" value to a set of callbacks. */
+static int
+op2cs(int op)
+{
+
+	switch (op) {
+	case NETWORK_OP_READ:
+		return (0);
+	case NETWORK_OP_WRITE:
+		return (1);
+	default:
+		assert(!"Invalid operation type in network_register");
+	}
+}
+
+/* Invoke the callback. */
+static int
+docallback(struct callback * c, int timedout)
+{
+	network_callback * cb;
+	int status;
+
+	/* Cancel any pending event callbacks. */
+	if (c->event_network_pending)
+		events_network_cancel(c->s, c->eop);
+	if (c->event_timer != NULL)
+		events_timer_cancel(c->event_timer);
+
+	/* Grab the callback function and empty the record. */
+	cb = c->callback;
+	c->callback = NULL;
+
+	/* Translate timeout status to network status. */
+	switch (timedout) {
+	case -1:
+		status = NETWORK_STATUS_CANCEL;
+		break;
+	case 0:
+		status = NETWORK_STATUS_OK;
+		break;
+	case 1:
+		status = NETWORK_STATUS_TIMEOUT;
+		break;
+	default:
+		assert(!"Invalid status to docallback");
+		return (-1);
+	}
+
+	/* Invoke callback. */
+	return ((cb)(c->cookie, status));
+}
+
+/* Callback from network_register when timer expires. */
+static int
+callback_timer(void * cookie)
+{
+	struct callback * c = cookie;
+
+	/* This callback is no longer pending. */
+	c->event_timer = NULL;
+
+	/* Do callback. */
+	return (docallback(c, 1));
+}
+
+/* Callback from network_register when socket is ready. */
+static int
+callback_network(void * cookie)
+{
+	struct callback * c = cookie;
+
+	/* This callback is no longer pending. */
+	c->event_network_pending = 0;
+
+	/* Do callback. */
+	return (docallback(c, 0));
+}
+
+/**
+ * network_register(fd, op, timeo, callback, cookie):
+ * Register a callback to be performed by network_select when file descriptor
+ * ${fd} is ready for operation ${op}, or once the timeout has expired.
+ */
+int
+network_register(int fd, int op, struct timeval * timeo,
+    network_callback * callback, void * cookie)
+{
+	CALLBACKS * csp;
+	CALLBACKS cs;
+	struct callback * c;
+	int osize;
+	int eop;
+
+	/* Sanity-check the file descriptor. */
+	if ((fd < 0) || (fd >= (int)FD_SETSIZE)) {
+		warn0("Invalid file descriptor: %d", fd);
+		goto err0;
+	}
+
+	/*
+	 * Figure out which set of callbacks we're dealing with and which
+	 * type of event we need to listen for.
+	 */
+	csp = &callbacks[op2cs(op)];
+	eop = eops[op2cs(op)];
+
+	/* Initialize array if required. */
+	if ((cs = *csp) == NULL) {
+		if ((cs = *csp = callbacks_init(0)) == NULL)
+			goto err0;
+	}
+
+	/* Enlarge array if necessary. */
+	if ((osize = (int)callbacks_getsize(cs)) <= fd) {
+		/* Resize. */
+		if (callbacks_resize(cs, fd + 1))
+			goto err0;
+
+		/* Initialize empty. */
+		for (; osize < fd + 1; osize++) {
+			*callbacks_get(cs, osize) = NULL;
+		}
+	}
+
+	/* Grab the relevant callback record. */
+	c = *callbacks_get(cs, fd);
+
+	/* If there is no record in that slot, allocate one. */
+	if (c == NULL) {
+		/* Allocate. */
+		if ((c = malloc(sizeof(struct callback))) == NULL)
+			goto err0;
+
+		/* Initialize. */
+		c->callback = NULL;
+		c->event_network_pending = 0;
+		c->event_timer = NULL;
+
+		/* Insert into table slot. */
+		*callbacks_get(cs, fd) = c;
+	}
+
+	/* Make sure we're not replacing an existing callback. */
+	if (c->callback != NULL) {
+		warn0("Replacing callback: op = %d, fd = %d", op, fd);
+		goto err0;
+	}
+
+	/* Set network operation parameters. */
+	c->callback = callback;
+	c->cookie = cookie;
+	c->s = fd;
+	c->eop = eop;
+
+	/* Register a timer event. */
+	if ((c->event_timer =
+	    events_timer_register(callback_timer, c, timeo)) == NULL)
+		goto err0;
+
+	/* Register a network event if not suspended. */
+	if (suspended[op2cs(op)] == 0) {
+		if (events_network_register(callback_network, c, fd, eop))
+			goto err1;
+		c->event_network_pending = 1;
+	} else {
+		c->event_network_pending = 0;
+	}
+
+	/* Success! */
+	return (0);
+
+err1:
+	events_timer_cancel(c->event_timer);
+	c->event_timer = NULL;
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * network_deregister(fd, op):
+ * Deregister the callback, if any, for operation ${op} on descriptor ${fd}.
+ * The callback will be called with a status of NETWORK_STATUS_CANCEL.
+ */
+int
+network_deregister(int fd, int op)
+{
+	CALLBACKS cs;
+	struct callback * c;
+
+	/* Figure out which set of callbacks we're dealing with. */
+	cs = callbacks[op2cs(op)];
+
+	/* Sanity-check: We should have a callbacks array. */
+	if (cs == NULL) {
+		warn0("Callbacks uninitialized");
+		goto err0;
+	}
+
+	/* Sanity-check the file descriptor. */
+	if ((fd < 0) || (fd >= (int)callbacks_getsize(cs))) {
+		warn0("Invalid file descriptor: %d", fd);
+		goto err0;
+	}
+
+	/* Grab the relevant callback record. */
+	c = *callbacks_get(cs, fd);
+
+	/* If there is no callback, return silently. */
+	if (c == NULL || c->callback == NULL)
+		return (0);
+
+	/* Invoke the callback. */
+	return (docallback(c, -1));
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * network_register_suspend(op):
+ * Suspend ${op} operations, on all file descriptors.
+ */
+int
+network_register_suspend(int op)
+{
+	CALLBACKS cs;
+	struct callback * c;
+	size_t i;
+
+	/* This direction is suspended. */
+	suspended[op2cs(op)] = 1;
+
+	/* Look up which set of callbacks we're dealing with. */
+	cs = callbacks[op2cs(op)];
+
+	/* If we have no callbacks, return immediately. */
+	if (cs == NULL)
+		return (0);
+
+	/* Scan through the callbacks... */
+	for (i = 0; i < callbacks_getsize(cs); i++) {
+		c = *callbacks_get(cs, i);
+
+		/* ... ignoring any which don't actually exist... */
+		if ((c == NULL) || (c->callback == NULL))
+			continue;
+
+		/* ... but cancelling the rest. */
+		if (c->event_network_pending) {
+			c->event_network_pending = 0;
+			if (events_network_cancel(c->s, c->eop))
+				goto err0;
+		}
+	}
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * network_register_resume(op):
+ * Resume pending ${op} operations, on all file descriptors.
+ */
+int
+network_register_resume(int op)
+{
+	CALLBACKS cs;
+	struct callback * c;
+	size_t i;
+
+	/* Not suspended any more. */
+	suspended[op2cs(op)] = 0;
+
+	/* Look up which set of callbacks we're dealing with. */
+	cs = callbacks[op2cs(op)];
+
+	/* If we have no callbacks, return immediately. */
+	if (cs == NULL)
+		return (0);
+
+	/* Scan through the callbacks... */
+	for (i = 0; i < callbacks_getsize(cs); i++) {
+		c = *callbacks_get(cs, i);
+
+		/* ... ignoring any which don't actually exist... */
+		if ((c == NULL) || (c->callback == NULL))
+			continue;
+
+		/* ... but starting the rest. */
+		if (c->event_network_pending == 0) {
+			c->event_network_pending = 1;
+			if (events_network_register(callback_network,
+			    c, c->s, c->eop))
+				goto err0;
+		}
+	}
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * network_register_fini(void):
+ * Free resources allocated.
+ */
+void
+network_register_fini(void)
+{
+	struct callback * c;
+	size_t i, j;
+
+	/* For each direction... */
+	for (i = 0; i < 2; i++) {
+		/* Skip uninitialized directions. */
+		if (callbacks[i] == NULL)
+			continue;
+
+		/* For each descriptor... */
+		for (j = 0; j < callbacks_getsize(callbacks[i]); j++) {
+			c = *callbacks_get(callbacks[i], j);
+
+			/* Skip records which don't exist. */
+			if (c == NULL)
+				continue;
+
+			/* If we have no callback, free the record. */
+			if (c->callback == NULL)
+				free(c);
+		}
+
+		/* Free the callbacks array. */
+		callbacks_free(callbacks[i]);
+	}
+}
diff -ruN tarsnap-autoconf-1.0.33/lib/network/tsnetwork_select.c tarsnap-autoconf-1.0.34/lib/network/tsnetwork_select.c
--- tarsnap-autoconf-1.0.33/lib/network/tsnetwork_select.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/lib/network/tsnetwork_select.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,98 @@
+#include "bsdtar_platform.h"
+
+#include "events.h"
+
+#include "tsnetwork_internal.h"
+
+#include "tsnetwork.h"
+
+/* Callback from network_select with zero timeout. */
+static int
+callback_dontsleep(void * cookie)
+{
+	int * done = cookie;
+
+	/* We've been called. */
+	*done = 1;
+
+	/* Success! */
+	return (0);
+}
+
+/**
+ * network_select(blocking):
+ * Call select(2) on file descriptors provided via network_register and make
+ * callbacks as appropriate (including timeouts).  Callbacks are deregistered
+ * before being performed.  If ${blocking} is non-zero, allow select(2) to
+ * block waiting for descriptors and timeouts.  Stop performing callbacks and
+ * return the first non-zero value returned by a callback if one occurs.
+ */
+int
+network_select(int blocking)
+{
+	int done = 0;
+
+	/*
+	 * If we want to avoid blocking on descriptors and timeouts, register
+	 * a callback for "right now", and spin until that callback occurs.
+	 * Otherwise, just let events run.
+	 */
+	if (blocking == 0) {
+		if (events_timer_register_double(callback_dontsleep,
+		    &done, 0.0) == NULL)
+			goto err0;
+		return (events_spin(&done));
+	} else {
+		return (events_run());
+	}
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * network_spin(done):
+ * Repeatedly call network_select until either an error occurs or the value
+ * pointed to by ${done} is non-zero.
+ */
+int
+network_spin(int * done)
+{
+
+	/* Hand this off to the events system. */
+	return (events_spin(done));
+}
+
+/**
+ * network_getselectstats(N, mu, va, max):
+ * Return and zero statistics on the time between select(2) calls.
+ */
+void
+network_getselectstats(double * NN, double * mu, double * va, double * max)
+{
+
+	/* Hand off to events code. */
+	events_network_selectstats(NN, mu, va, max);
+}
+
+/**
+ * network_fini(void):
+ * Free resources associated with the network subsystem.
+ */
+void
+network_fini(void)
+{
+
+	/* Clean up network registrations. */
+	network_register_fini();
+
+	/* Clean up sleeps. */
+	network_sleep_fini();
+
+	/* Clean the underlying events system. */
+	events_shutdown();
+}
diff -ruN tarsnap-autoconf-1.0.33/lib/network/tsnetwork_sleep.c tarsnap-autoconf-1.0.34/lib/network/tsnetwork_sleep.c
--- tarsnap-autoconf-1.0.33/lib/network/tsnetwork_sleep.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/lib/network/tsnetwork_sleep.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,161 @@
+#include <stdlib.h>
+#include <string.h>
+
+#include "elasticarray.h"
+#include "events.h"
+#include "warnp.h"
+
+#include "tsnetwork.h"
+#include "tsnetwork_internal.h"
+
+/* Sleepers. */
+struct sleeper {
+	network_callback * callback;
+	void * cookie;
+	void * event_cookie;
+};
+ELASTICARRAY_DECL(SLEEPERS, sleepers, struct sleeper *);
+static SLEEPERS sleepers = NULL;
+
+/* Callback from network_sleep when timer expires. */
+static int
+callback_timer(void * cookie)
+{
+	struct sleeper * sp = cookie;
+
+	/* This callback is no longer pending. */
+	sp->event_cookie = NULL;
+
+	/* Do callback. */
+	return ((sp->callback)(sp->cookie, NETWORK_STATUS_TIMEOUT));
+}
+
+/**
+ * network_sleep(timeo, callback, cookie):
+ * Register a callback to be performed by network_select once the specified
+ * timeout has expired.  Return a handle which can be passed to
+ * network_desleep().
+ */
+int
+network_sleep(struct timeval * timeo,
+    network_callback * callback, void * cookie)
+{
+	struct sleeper s;
+	struct sleeper * sp = NULL;	/* Silence bogus gcc warning. */
+	size_t h;
+
+	/* Initialize array if required. */
+	if (sleepers == NULL) {
+		if ((sleepers = sleepers_init(0)) == NULL)
+			goto err0;
+	}
+
+	/* Construct sleeper record. */
+	s.callback = callback;
+	s.cookie = cookie;
+	s.event_cookie = NULL;
+
+	/* Search for empty space. */
+	for (h = 0; h < sleepers_getsize(sleepers); h++) {
+		sp = *sleepers_get(sleepers, h);
+		if (sp->event_cookie == NULL) {
+			/* Use this one. */
+			memcpy(sp, &s, sizeof(struct sleeper));
+			break;
+		}
+	}
+
+	/* If we didn't find an empty space, add a new sleeper. */
+	if (h == sleepers_getsize(sleepers)) {
+		/* Don't have too many sleepers... */
+		if (h == 1024) {
+			warn0("Too many sleepers");
+			goto err0;
+		}
+
+		/* Allocate a record. */
+		if ((sp = malloc(sizeof(struct sleeper))) == NULL)
+			goto err0;
+
+		/* Copy data in. */
+		memcpy(sp, &s, sizeof(struct sleeper));
+
+		/* Append the record. */
+		if (sleepers_append(sleepers, &sp, 1))
+			goto err0;
+	}
+
+	/* Register the timer event. */
+	if ((sp->event_cookie =
+	    events_timer_register(callback_timer, sp, timeo)) == NULL)
+		goto err0;
+
+	/* Success! */
+	return (h);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * network_desleep(handle):
+ * Deregister the callback associated with the provided handle.  The
+ * callback will be called with a status of NETWORK_STATUS_CANCEL.
+ */
+int
+network_desleep(int handle)
+{
+	struct sleeper * sp;
+
+	/* Sanity-check the handle. */
+	if (handle >= (int)sleepers_getsize(sleepers)) {
+		warn0("Invalid sleeper handle: %d", handle);
+		goto err0;
+	}
+
+	/* Grab the relevant sleeper record. */
+	sp = *sleepers_get(sleepers, handle);
+
+	/* If there is no timer, return silently. */
+	if (sp->event_cookie == NULL)
+		return (0);
+
+	/* Cancel the timer. */
+	events_timer_cancel(sp->event_cookie);
+	sp->event_cookie = NULL;
+
+	/* Invoke the callback. */
+	return ((sp->callback)(sp->cookie, NETWORK_STATUS_CANCEL));
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * network_sleep_fini(void):
+ * Free resources allocated.
+ */
+void
+network_sleep_fini(void)
+{
+	struct sleeper * sp;
+	size_t i;
+
+	/* Nothing to do if we're uninitialized. */
+	if (sleepers == NULL)
+		return;
+
+	/* Free records. */
+	for (i = 0; i < sleepers_getsize(sleepers); i++) {
+		sp = *sleepers_get(sleepers, i);
+
+		/* If this sleep is no longer in progress, free the record. */
+		if (sp->event_cookie == NULL)
+			free(sp);
+	}
+
+	/* Free the sleepers array. */
+	sleepers_free(sleepers);
+}
diff -ruN tarsnap-autoconf-1.0.33/lib/network/tsnetwork_writeq.c tarsnap-autoconf-1.0.34/lib/network/tsnetwork_writeq.c
--- tarsnap-autoconf-1.0.33/lib/network/tsnetwork_writeq.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/lib/network/tsnetwork_writeq.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,249 @@
+#include "bsdtar_platform.h"
+
+#include <sys/time.h>
+
+#include <stdlib.h>
+#include <string.h>
+
+#include "tsnetwork_internal.h"
+#include "tvmath.h"
+#include "warnp.h"
+
+#include "tsnetwork.h"
+
+struct network_writeq_buf {
+	const uint8_t * buf;
+	size_t buflen;
+	struct timeval timeo;
+	int abstimeo;
+	network_callback * callback;
+	void * cookie;
+	struct network_writeq_buf * next;
+};
+struct network_writeq_internal {
+	int fd;
+	struct network_writeq_buf * head;
+	struct network_writeq_buf ** tailptr;
+};
+
+static int dowrite(struct network_writeq_internal *);
+static network_callback callback_bufdone;
+
+static int
+dowrite(struct network_writeq_internal * Q)
+{
+	struct network_writeq_buf * QB = Q->head;
+	struct timeval timeo;
+
+	/* Figure out how long to allow for this buffer write. */
+	memcpy(&timeo, &QB->timeo, sizeof(struct timeval));
+	if (QB->abstimeo && tvmath_subctime(&timeo))
+		goto err0;
+
+	/* Write the buffer. */
+	if (tsnetwork_write(Q->fd, QB->buf, QB->buflen, &timeo, &timeo,
+	    callback_bufdone, Q))
+		goto err0;
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * callback_bufdone(cookie, status):
+ * Call the upstream callback for the buffer at the head of the write queue
+ * ${cookie}, remove it from the queue, and write the next buffer.
+ */
+static int
+callback_bufdone(void * cookie, int status)
+{
+	struct network_writeq_internal * Q = cookie;
+	struct network_writeq_buf * head_old;
+	int rc;
+
+	/* Unlink the current buffer from the queue. */
+	head_old = Q->head;
+	Q->head = head_old->next;
+
+	/* Update tail pointer if necessary. */
+	if (Q->tailptr == &head_old->next)
+		Q->tailptr = &Q->head;
+
+	/*
+	 * A callback of NETWORK_STATUS_CLOSED in response to an attempt to
+	 * write zero bytes is really a NETWORK_STATUS_ZEROBYTE.
+	 */
+	if ((status == NETWORK_STATUS_CLOSED) && (head_old->buflen == 0))
+		status = NETWORK_STATUS_ZEROBYTE;
+
+	/*
+	 * If there's another buffer waiting to be written, register it to
+	 * be sent.  If not and we're not handling an error, uncork the
+	 * socket.
+	 */
+	if (Q->head != NULL) {
+		if (dowrite(Q))
+			goto err1;
+	} else {
+		if ((status == NETWORK_STATUS_OK) && network_uncork(Q->fd))
+			status = NETWORK_STATUS_ERR;
+	}
+
+	/* Call the upstream callback. */
+	rc = (head_old->callback)(head_old->cookie, status);
+
+	/* Free the write parameters structure. */
+	free(head_old);
+
+	/* Return value from callback. */
+	return (rc);
+
+err1:
+	(head_old->callback)(head_old->cookie, status);
+	free(head_old);
+
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * network_writeq_init(fd):
+ * Construct a queue to be used for writing data to ${fd}.
+ */
+NETWORK_WRITEQ *
+network_writeq_init(int fd)
+{
+	struct network_writeq_internal * Q;
+
+	/* Allocate memory. */
+	if ((Q = malloc(sizeof(struct network_writeq_internal))) == NULL)
+		goto err0;
+
+	/* Initialize structure. */
+	Q->fd = fd;
+	Q->head = NULL;
+	Q->tailptr = &Q->head;
+
+	/* Success! */
+	return (Q);
+
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/**
+ * _network_writeq_add(Q, buf, buflen, timeo, callback, cookie, abstimeo):
+ * Add a buffer write to the specified write queue.  The callback function
+ * will be called when the write is finished, fails, or is cancelled.
+ * If ${abstimeo} is zero, the timeout is relative to when the buffer in
+ * question starts to be written (i.e., when the previous buffered write
+ * finishes); otherwise, the timeout is relative to the present time.  If
+ * ${buflen} is zero, the callback will be performed, at the appropriate
+ * point, with a status of NETWORK_STATUS_ZEROBYTE.
+ */
+int
+_network_writeq_add(NETWORK_WRITEQ * Q, const uint8_t * buf, size_t buflen,
+    struct timeval * timeo, network_callback * callback, void * cookie,
+    int abstimeo)
+{
+	struct network_writeq_buf * QB;
+	struct network_writeq_buf ** tailptr_old;
+	struct network_writeq_buf * head_old;
+
+	/* Wrap parameters into a structure. */
+	if ((QB = malloc(sizeof(struct network_writeq_buf))) == NULL)
+		goto err0;
+	QB->buf = buf;
+	QB->buflen = buflen;
+	memcpy(&QB->timeo, timeo, sizeof(struct timeval));
+	QB->abstimeo = abstimeo;
+	QB->callback = callback;
+	QB->cookie = cookie;
+	QB->next = NULL;
+
+	/* Compute absolute time if appropriate. */
+	if (abstimeo && tvmath_addctime(&QB->timeo))
+		goto err1;
+
+	/* Add this to the write queue. */
+	head_old = Q->head;
+	tailptr_old = Q->tailptr;
+	*Q->tailptr = QB;
+	Q->tailptr = &QB->next;
+
+	/* If the queue head was NULL, we need to kick off the writing. */
+	if (head_old == NULL) {
+		/* Cork the socket so that we don't send small packets. */
+		if (network_cork(Q->fd))
+			goto err2;
+
+		if (dowrite(Q))
+			goto err2;
+	}
+
+	/* Success! */
+	return (0);
+
+err2:
+	Q->tailptr = tailptr_old;
+	*Q->tailptr = NULL;
+err1:
+	free(QB);
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * network_writeq_cancel(Q):
+ * Cancel all queued writes, including any partially completed writes.  Note
+ * that since this leaves the connection in an indeterminate state (there is
+ * no way to know how much data from the currently in-progress write was
+ * written) this should probably only be used prior to closing a connection.
+ * The callbacks for each pending write will be called with a status of
+ * NETWORK_STATUS_DEQUEUE, and network_writeq_cancel will return the first
+ * non-zero value returned by a callback.
+ */
+int
+network_writeq_cancel(NETWORK_WRITEQ * Q)
+{
+	int rc = 0, rc2;
+
+	/* Keep on deregistering callbacks until the queue is empty. */
+	while (Q->head != NULL) {
+		rc2 = network_deregister(Q->fd, NETWORK_OP_WRITE);
+		rc = rc ? rc : rc2;
+	}
+
+	/* Return first non-zero result from deregistration. */
+	return (rc);
+}
+
+/**
+ * network_writeq_free(Q):
+ * Free the specified write queue.  If there might be any pending writes,
+ * network_writeq_cancel should be called first.
+ */
+void
+network_writeq_free(NETWORK_WRITEQ * Q)
+{
+	struct network_writeq_buf * head_old;
+
+	/* Repeat until the queue is empty. */
+	while (Q->head != NULL) {
+		/* Unlink the current buffer from the queue. */
+		head_old = Q->head;
+		Q->head = Q->head->next;
+
+		/* Free the write parameters structure. */
+		free(head_old);
+	}
+
+	/* Free the queue structure itself. */
+	free(Q);
+}
diff -ruN tarsnap-autoconf-1.0.33/lib/scryptenc/scryptenc.c tarsnap-autoconf-1.0.34/lib/scryptenc/scryptenc.c
--- tarsnap-autoconf-1.0.33/lib/scryptenc/scryptenc.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/scryptenc/scryptenc.c	2013-07-06 14:38:21.000000000 -0700
@@ -37,13 +37,15 @@
 
 #include <openssl/aes.h>
 
+#include "crypto_aesctr.h"
+#include "crypto_entropy.h"
+#include "sha256.h"
+#include "sysendian.h"
+
 #include "crypto.h"
-#include "crypto_internal.h"
 #include "crypto_scrypt.h"
 #include "memlimit.h"
 #include "scryptenc_cpuperf.h"
-#include "sha256.h"
-#include "sysendian.h"
 
 #include "scryptenc.h"
 
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/COPYRIGHT tarsnap-autoconf-1.0.34/libcperciva/COPYRIGHT
--- tarsnap-autoconf-1.0.33/libcperciva/COPYRIGHT	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/COPYRIGHT	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,25 @@
+The code and documentation in this directory ("libcperciva") is distributed
+under the following terms:
+
+Copyright 2005-2013 Colin Percival.  All rights reserved.
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions
+are met:
+1. Redistributions of source code must retain the above copyright
+   notice, this list of conditions and the following disclaimer.
+2. Redistributions in binary form must reproduce the above copyright
+   notice, this list of conditions and the following disclaimer in the
+   documentation and/or other materials provided with the distribution.
+
+THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+SUCH DAMAGE.
